<?php
/*
// isdf - inventory system search
// Author: Carsten Schoene
//
// $LastChangedDate: 2012-07-20 21:09:25 +0200 (Fr, 20. Jul 2012) $
// $Rev: 1619 $
*/

// define our name
define('MYNAME', "isdf-client-status");
// open syslog connection
openlog(MYNAME,LOG_PID | LOG_ODELAY,LOG_MAIL);

// check for required extensions
if ( ! extension_loaded("mysql") ) {
        if ( ! dl("mysql") ) {
                syslog(LOG_ERR,"mysql extension not loaded!");
                exit;
        }
}

// load additional files
define('BASE',dirname(__FILE__));
require_once("MDB2.php");
require_once(BASE . "/config.inc.php");
require_once(BASE . "/config-custom.inc.php");
require_once(BASE . "/db.inc.php");

echo '<html><head>
<title>inventory system - client-status</title>
</head>
<body>
';
// create database connection
$dbh =& MDB2::singleton($config['isdf']['db'], $config['mdb2']['options'] );

$datasql = "SELECT inv_system_id, datakey, value FROM inv_system_properties WHERE (datakey = 'get_system_uuid' OR
		 datakey = 'get_system_default_ip' OR
		 datakey = 'get_system_hostname' OR
		 datakey = 'get_system_software' OR
		 datakey = 'get_system_date') ORDER BY inv_system_id";

$idres = $dbh->query($datasql);
if (PEAR::isError($idres)) {
	syslog(LOG_ERR, "MDB2 idres: " . $idres->getMessage());
} else {
	$data = array();
	while (( $idrow = $idres->fetchRow(MDB2_FETCHMODE_ASSOC) )) {
			if ( $idrow['datakey'] == "get_system_software" ) {
				// extract inventory-system 
				preg_match('/(ix-)?inventory-system-\d+\.\d+\.rev\d+-\d+\.\d+/', $idrow['value'],$treffer);
				$idrow['value'] = $treffer[0];
			} elseif ( $idrow['datakey'] == "get_system_date" ) {
				// convert to unix timestamp
				$idrow['value'] = strtotime($idrow['value']);
			}
			//array_push($data,$idrow);
			$data[$idrow['inv_system_id']][$idrow['datakey']] = $idrow['value'];
	}
}
$result = array();
$ver = preg_replace('/-server/','',trim(exec("rpm -qa|grep inventory-system-server")));
$lastlogin = time() - 172800;
echo 'Server Software version: ' . $ver . ' <br/>';
echo 'Server allowed last login: ' . $lastlogin . ' (' . date("Y-m-d H:i:s",$lastlogin) . ') <br/>';
foreach ( $data as $idx ) {
	if ( $idx['get_system_date'] < $lastlogin ) {
		$idx['last_login_to_old'] = 1;
		array_push($result, $idx);
		continue;
	} elseif ( trim($idx['get_system_software']) < $ver ) {
		$idx['software_to_old'] = 1;
		array_push($result, $idx);
		continue;
	}
}
echo '<table><tr><th>Key:</th><td>Value:</th></tr>';
echo '</table>';
echo '<pre>';
print_r($result);
echo '</pre>';
echo '</body></html>';
$dbh->disconnect();
?>
